toolkit = {};
toolkit.debug = true;
toolkit.storage_key = 'hotel';
// 资源文件的请求路径
//toolkit.assetsBaseUrl = "http://192.168.0.134";
toolkit.assetsBaseUrl = "https://api.slytlj.com";
//版本号
var Edition = 'v1';
// 服务器请求基本地址
toolkit.serverBaseUrl = toolkit.assetsBaseUrl + "/api/" + Edition + "/";
//================================================
// 存储方法
toolkit.storage = {};
toolkit.storage.key = function(key, type_of) {
	if(arguments.length == 2) {
		if(type_of == "object") {
			return JSON.parse(plus.storage.getItem(key))
		} else {
			return plus.storage.getItem(key)
		}
	}
	if(arguments[2] === "" || arguments[2] == null) {
		plus.storage.removeItem(key);
		return;
	}
	if(typeof(arguments[2]) == "object") {
		plus.storage.setItem(key, JSON.stringify(arguments[2]));
		return;
	} else {
		plus.storage.setItem(key, arguments[2]);
	}
};

//适配判断
//获取设备信息设置高度
if(mui.os.ios) {
	if(plus.device.model == 'iPhoneX') {
		$('.header').css({
			height: "88px",
			paddingTop: "44px"
		});
		$('.mui-bar-nav~.mui-content').css({
			paddingTop: "88px"
		});
		$('.mui-bar~.mui-content .mui-fullscreen').css({
			top: "88px !important"
		});
	};
};

/**
 * 应用本地配置
 **/
toolkit.app = {};
toolkit.app.name = "悦棠旅居app"
toolkit.app.settings = function() {
	if(arguments.length == 0) {
		return toolkit.storage.key('$settings', "object")
	}
	return toolkit.storage.key('$settings', "object", arguments[0])
};
toolkit.app.baseInfo = function() {
	if(arguments.length == 0) {
		return toolkit.storage.key('app_baseinfo', "object")
	}
	return toolkit.storage.key('app_baseinfo', "object", arguments[0])
};

//======================================================
// 页面封装
toolkit.pages = {}
toolkit.pages.loginPage = function() {
	return plus.webview.getWebviewById('login')
}
toolkit.pages.currentPage = function() {
	return plus.webview.currentWebview();
};
toolkit.pages.getPage = function(id) {
	return id ? plus.webview.getWebviewById(id) : null;
};
toolkit.pages.home = function() {
	return plus.webview.getLaunchWebview()
}
toolkit.pages.show = function(id, ani, time, func) {
	if(id) plus.webview.show(id, ani, time, func);
};
toolkit.pages.hide = function(id, ani, time) {
	if(id) plus.webview.hide(id, ani, time);
};
toolkit.pages.fire = function(id, evelname, values) {
	mui.fire(toolkit.pages.getPage(id), evelname, values);
};
//=========================================================
// 网络封装
toolkit.net = {};
//toolkit.net.web_onError = function(errorData, customOnError) {
//	customOnError = customOnError || mui.noop;
//	switch(errorData.code) {
//		case 'FAILED_NETWORK':
//			mui.toast('当前网络不佳');
//			customOnError(errorData)
//			break;
//		case 'NO_PERMISSIONS':
//			mui.toast("您无权访问该模块");
//			customOnError(errorData)
//			break;
//		case 'INVALID_TOKEN':
//			//跳转到登陆页
//			toolkit.pages.loginPage().show("slide-in-bottom", 300)
//			break;
//		default:
//			//除了前面两个错误其他错误传递出去
//			customOnError(errorData)
//	}
//};
// 封装一个基本请求
toolkit.net.web_query = function(func_url, params, onSuccess, onError, retry, requestType, async) {
	var onSuccess = arguments[2] ? arguments[2] : function() {};
	var onError = arguments[3] ? arguments[3] : mui.noop;
	var retry = arguments[4] ? arguments[4] : 1;
	var async = arguments[5] ? arguments[5] : true;
	var token = toolkit.user.access_token() ? toolkit.user.access_token() : "";
	func_url = toolkit.serverBaseUrl + func_url;
	plus.nativeUI.showWaiting("Loading");
	//	console.log(token);
	//	console.log(JSON.stringify(params));  
	mui.ajax(func_url, {
		data: params,
		async: async,
		dataType: 'json',
		type: requestType,
		timeout: 600000,
		headers: {
			token: token
		},
		success: function(data) {
			plus.nativeUI.closeWaiting();
			//			debug("Server Response:" + JSON.stringify(data))
			onSuccess(data);
		},
		error: function(xhr, type, errorThrown) {
			//			console.log(JSON.stringify(xhr)) 
			plus.nativeUI.closeWaiting();
			//			mui.alert("当前网络不佳,请重新启动应用");
			debug(errorThrown + "-------" + func_url);
			retry--;
			if(retry > 0) return toolkit.net.web_query(func_url, params, onSuccess, onError, retry, requestType);
			onError(errorThrown);
		}
	})
};

// 封装一个的get请求
// cmd 请求参数
// params 参数数据
// onSuccess 成功回调
// onError 失败回调
// retry 重试次数
toolkit.net.web_get = function(func_url, params, onSuccess, onError, retry) {
	toolkit.net.web_query(func_url, params, onSuccess, onError, retry, "get")
};
toolkit.net.web_post = function(func_url, params, onSuccess, onError, retry) {
	toolkit.net.web_query(func_url, params, onSuccess, onError, retry, "post")
};
toolkit.net.web_put = function(func_url, params, onSuccess, onError, retry) {
	toolkit.net.web_query(func_url, params, onSuccess, onError, retry, "put")
};
toolkit.net.web_delete = function(func_url, params, onSuccess, onError, retry) {
	toolkit.net.web_query(func_url, params, onSuccess, onError, retry, "delete")
};

//========================================================
//网络环境检查
toolkit.network = {}
toolkit.network.type = function() {
	var types = {};
	types[plus.networkinfo.CONNECTION_UNKNOW] = "未知";
	types[plus.networkinfo.CONNECTION_NONE] = "无";
	types[plus.networkinfo.CONNECTION_ETHERNET] = "以太网";
	types[plus.networkinfo.CONNECTION_WIFI] = "WIFI";
	types[plus.networkinfo.CONNECTION_CELL2G] = "2G";
	types[plus.networkinfo.CONNECTION_CELL3G] = "3G";
	types[plus.networkinfo.CONNECTION_CELL4G] = "4G";
	return types[plus.networkinfo.getCurrentType()]
};
//是否wifi
toolkit.network.is_wifi = function() {
	return toolkit.network.type() == "WIFI" ? true : false
};
//网络是否连接
toolkit.network.is_connection = function() {
	return toolkit.network.type() == "无" ? false : true
};
//根据网络触发条件
toolkit.network.is_callback = function(network_name, onSuccess, onError) {
	var onSuccess = onSuccess || mui.noop;
	var onError = onError || mui.noop;
	if(toolkit.network.type() == network_name) {
		onSuccess()
	} else {
		onError()
	}
};
//流量提醒
toolkit.network.traffic_alert = function(content, onSuccess, onCancel) {
	var onSuccess = onSuccess || mui.noop;
	var onCancel = onCancel || mui.noop;
	if(!toolkit.network.is_wifi()) {
		mui.confirm(content, '流量提醒', ["确认", "取消"], function(e) {
			if(e.index == 0) {
				onSuccess()
			} else {
				onCancel()
			}
		})
	} else {
		onSuccess()
	}
};
//下载
//app_path 为应用本地路径如 "_doc/books"
toolkit.network.down_file_to = function(url, cover, app_path, onSuccess, onError) {
	var app_path = app_path || "_downloads";
	var onSuccess = onSuccess || mui.noop;
	var onError = onError || mui.noop;
	var cover = cover || false;
	var file_path = app_path + "/" + url.substr(url.lastIndexOf('/') + 1)
	var downLoader = plus.downloader.createDownload(url, {
		method: 'GET',
		filename: file_path
	}, function(download, status) {
		if(status == 200 && download.state == 4) {
			var fileName = download.filename;
			onSuccess(fileName);
		} else {
			mui.toast("下载失败");
			onError(url)
		}
	});
	if(cover) {
		downLoader.start();
	} else {
		plus.io.resolveLocalFileSystemURL(file_path, function(entry) {
			downLoader.abort(); //取消下载
			onSuccess(file_path);
		}, function(error) {
			downLoader.start();
		});
	}

};

//========================================================
// 用户封装
toolkit.user = {};
toolkit.user.user_info_key = toolkit.storage_key + 'user_info';
toolkit.user.access_token_key = toolkit.storage_key + 'access_token';
toolkit.user.clear_login = function() {
	toolkit.storage.key(toolkit.user.user_info_key, "object", null) //清除用户基本信息
};
//是否登录
toolkit.user.has_login = function() {
	if(toolkit.user.access_token()) {
		return true;
	} else {
		return false;
	}
};

//用户令牌
toolkit.user.access_token = function() {
	if(arguments.length == 0) {
		return toolkit.storage.key(toolkit.user.access_token_key, "string")
	}
	return toolkit.storage.key(toolkit.user.access_token_key, "string", arguments[0]);
};
toolkit.user.id = function() {
	return toolkit.user.info().id;
};
//用户信息
toolkit.user.info = function() {
	if(arguments.length == 0) {
		return toolkit.storage.key(toolkit.user.user_info_key, "object")
	}
	return toolkit.storage.key(toolkit.user.user_info_key, "object", arguments[0])
};
//选中城市
toolkit.curr_city = function() {
	if(arguments.length == 0) {
		return toolkit.storage.key("curr_city", "object")
	}
	return toolkit.storage.key("curr_city", "object", arguments[0])
};

//定位信息
toolkit.location = function() {
	if(arguments.length == 0) {
		return toolkit.storage.key("location", "object")
	}
	return toolkit.storage.key("location", "object", arguments[0])
};

//更新用户信息
//toolkit.user.updateInfo = function(callback) {
//	callback = callback || mui.noop;
//	toolkit.net.web_get("/users/get_info", {}, function(data) {
////		toolkit.user.access_token(data.access_token)
////		toolkit.user.info(data)
//			//将登录数据写入到用户信息总保存
//		return callback(data)
//	}, function(error) {
//		mui.toast(error.msg);
//	})
//};

//用户必须登录，如果没有登录调用登录但不回调，如果已经登录的就直接回调
toolkit.user.userMastLogin = function(callback) {
	callback = callback || mui.noop;
	if(toolkit.user.has_login()) {
		return callback()
	} else {
		//跳转到登陆页
		var menu = plus.webview.getWebviewById("login") || mui.noop;
		var showMenu = false;
		var _self = plus.webview.currentWebview() || mui.noop;;
		_self.addEventListener('maskClick', closeMenu);
		var isInTransition = false;
		openMenu();
		/**
		 * 显示侧滑菜单
		 */
		function openMenu() {
			if(isInTransition) {
				return;
			}
			if(!showMenu) {
				//侧滑菜单处于隐藏状态，则立即显示出来；
				isInTransition = true;
				menu.setStyle({
					mask: 'rgba(0,0,0,0)',
					height: '100%'
				}); //menu设置透明遮罩防止点击
				menu.show('slide-in-bottom', 300, function() {
					//主窗体显示遮罩
					//					_self.setStyle({
					//						mask: 'rgba(0,0,0,0.3)'
					//					});
					mui.later(function() {
						isInTransition = false;
						menu.setStyle({
							mask: "none"
						}); //移除menu的mask
					}, 350);
					showMenu = true;
				});
			}
		};
		/**
		 * 关闭菜单
		 */
		function closeMenu() {
			if(isInTransition) {
				return;
			}
			if(showMenu) {
				//关闭遮罩；
				//主窗体开始侧滑；
				isInTransition = true;
				//				_self.setStyle({
				//					mask: 'none'
				//				});
				showMenu = false;
				//等动画结束后，隐藏菜单webview，节省资源；
				mui.later(function() {
					isInTransition = false;
					menu.hide("slide-out-bottom", 300);
				}, 50);
			}
		};
	}
};
//用户登录
//toolkit.user.login = function(loginInfo, callback) {
//	callback = callback || mui.noop;
//	toolkit.net.web_post("accountLogin", loginInfo,
//		function(data) {
//			return callback(data)
//		},
//		function(error) {
//			plus.nativeUI.closeWaiting();
//			mui.toast(error);
//		})
//};

//用户注册
//toolkit.user.reg = function(regInfo, callback) {
//	callback = callback || mui.noop;
//	toolkit.net.web_post("riderRegister", regInfo,
//		function(data) {
//			console.log(JSON.stringify(data))
//			return callback(data)
//		},
//		function(error) {
//			mui.toast('发送验证码错误');
//		})
//};
//获取验证码
toolkit.user.getVcode = function(phone, params_type, callback) {
	callback = callback || mui.noop;
	toolkit.net.web_post("sendVerifyCode", {
			phone: phone,
			type: params_type
		},
		function(data) {
			return callback(data);
		},
		function(error) {
			mui.toast('获取验证码错误');
		})
};
//===========================================
//工具集合
toolkit.utils = {};
/**  
 * js时间对象的格式化; 
 * eg:format="yyyy-MM-dd hh:mm:ss";   
 */
Date.prototype.format = function(format) {
	var o = {
		"M+": this.getMonth() + 1, //month   
		"d+": this.getDate(), //day   
		"h+": this.getHours(), //hour   
		"m+": this.getMinutes(), //minute   
		"s+": this.getSeconds(), //second   
		"q+": Math.floor((this.getMonth() + 3) / 3), //quarter   
		"S": this.getMilliseconds() //millisecond   
	}
	var week = ["周日", "周一", "周二", "周三", "周四", "周五", "周六"];
	if(/(y+)/.test(format)) {
		format = format.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
	}
	if(/(w+)/.test(format)) {
		format = format.replace(RegExp.$1, week[this.getDay()]);
	}
	for(var k in o) {
		if(new RegExp("(" + k + ")").test(format)) {
			format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
		}
	}
	return format;
};
//字符串格式时间格式化
toolkit.utils.DateTimeFormat = function(date_string, format) {
	var d = new Date(date_string)
	return d.format(format)
};
//资源路径
toolkit.utils.url_for = function(path) {
	return toolkit.assetsBaseUrl + path
};
//资源路径加上随机数
toolkit.utils.url_for_random = function(path) {
	return toolkit.assetsBaseUrl + path + "?t=" + Math.random();
}
//取得select选择项的值
toolkit.utils.getSelectedValue = function(id) {
	var obj = document.getElementById(id);
	var index = obj.selectedIndex;
	return obj.options[index].value;
};
//设置select的选中值
toolkit.utils.setSelectedValue = function(id, value) {
	var obj = document.getElementById(id);
	for(var i = 0; i < obj.options.length; i++) {
		if(obj.options[i].value == value) {
			obj.options[i].selected = true;
			break;
		}
	}
}
//取得数组值
toolkit.utils.getInputsArrayValue = function(selector, remove_spaces) {
	var objects = []
	remove_spaces = remove_spaces || true
	mui(selector).each(function(index, item) {
		if(item.value == "" && remove_spaces == true) {
			return
		} else {
			objects.push(item.value)
		}
	})
	return objects
}
//取得switch的选项值
toolkit.utils.getSwitchValue = function(id) {
	var obj = document.getElementById(id);
	if(obj.classList.contains("mui-active")) {
		return obj.dataset.activeValue;
	} else {
		return obj.dataset.value;
	}
};
//将提交的参数格式化成为rails格式的对象参数
//toolkit.utils.formatToRailsParams = function(params, obj_name) {
//	var obj = {};
//	for(var name in params) {
//		obj[obj_name + "[" + name + "]"] = params[name]
//	}
//	return obj;
//};
//货币格式化
toolkit.utils.numberToCurrency = function(number, places, symbol, thousand, decimal) {
	places = !isNaN(places = Math.abs(places)) ? places : 2;
	symbol = symbol !== undefined ? symbol : "￥";
	thousand = thousand || ",";
	decimal = decimal || ".";
	var negative = number < 0 ? "-" : "";
	var i = parseInt(number = Math.abs(+number || 0).toFixed(places), 10) + "";
	var j = (j = i.length) > 3 ? j % 3 : 0;
	return symbol + negative + (j ? i.substr(0, j) + thousand : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + thousand) + (places ? decimal + Math.abs(number - i).toFixed(places).slice(2) : "");
}
//显示loading
toolkit.utils.showLoading = function(container) {
	var loading = document.createElement('div');
	loading.className = "mui-loading";
	loading.innerHTML = "<span class=\"mui-spinner\"><\/span>";
	container.appendChild(loading);
	return loading;
}

//gps 距离计算
toolkit.utils.getDisance = function(positionA, positionB) {
	function toRad(d) {
		return d * Math.PI / 180;
	}
	var lat1 = positionA.coords.latitude,
		lng1 = positionA.coords.longitude
	var lat2 = positionB.coords.latitude,
		lng2 = positionB.coords.longitude
	var dis = 0;
	var radLat1 = toRad(lat1);
	var radLat2 = toRad(lat2);
	var deltaLat = radLat1 - radLat2;
	var deltaLng = toRad(lng1) - toRad(lng2);
	var dis = 2 * Math.asin(Math.sqrt(Math.pow(Math.sin(deltaLat / 2), 2) + Math.cos(radLat1) * Math.cos(radLat2) * Math.pow(Math.sin(deltaLng / 2), 2)));
	return dis * 6378137;
}

//移除节点
toolkit.utils.removeNode = function(node) {
	var parentNode = node.parentNode
	parentNode.removeChild(node)
}

//=========================================================
//表单验证
toolkit.validator = function(fields, successCallback, failedCallback) {
	var errors = [];
	var regexs = {
		// 匹配 max_length(12) => ["max_length",12]
		rule: /^(.+?)\((.+)\)$/,
		// 数字
		numericRegex: /^[0-9]+$/,
		// 价格
		money: /(^[1-9]\d*(\.\d{1,2})?$)|(^0(\.\d{1,2})?$)/,
		/**
		 * @descrition:邮箱规则
		 * 1.邮箱以a-z、A-Z、0-9开头，最小长度为1.
		 * 2.如果左侧部分包含-、_、.则这些特殊符号的前面必须包一位数字或字母。
		 * 3.@符号是必填项
		 * 4.右则部分可分为两部分，第一部分为邮件提供商域名地址，第二部分为域名后缀，现已知的最短为2位。最长的为6为。
		 * 5.邮件提供商域可以包含特殊字符-、_、.
		 */
		email: /^[a-z0-9]+([._\\-]*[a-z0-9])*@([a-z0-9]+[-a-z0-9]*[a-z0-9]+.){1,63}[a-z0-9]+$/,
		/**
		 * [ip ipv4、ipv6]
		 * "192.168.0.0"
		 * "192.168.2.3.1.1"
		 * "235.168.2.1"
		 * "192.168.254.10"
		 * "192.168.254.10.1.1"
		 */
		ip: /^(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])((\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])){3}|(\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])){5})$/,
		/**
		 * @descrition:判断输入的参数是否是个合格的固定电话号码。
		 * 待验证的固定电话号码。
		 * 国家代码(2到3位)-区号(2到3位)-电话号码(7到8位)-分机号(3位)
		 **/
		fax: /^(([0\+]\d{2,3}-)?(0\d{2,3})-)(\d{7,8})(-(\d{3,}))?$/,
		/**
		 *@descrition:手机号码段规则
		 * 13段：130、131、132、133、134、135、136、137、138、139
		 * 14段：145、147
		 * 15段：150、151、152、153、155、156、157、158、159
		 * 17段：170、176、177、178
		 * 18段：180、181、182、183、184、185、186、187、188、189
		 * 国际码 如：中国(+86)
		 */
		//      phone: /^((\+?[0-9]{1,4})|(\(\+86\)))?(13[0-9]|14[57]|15[012356789]|17[0678]|18[0-9])\d{8}$/,
		phone: /^1\d{10}$/,
		/**
		 * @descrition 匹配 URL
		 */
		url: /[a-zA-z]+:\/\/[^\s]/,
		/**
		 * @description 日期
		 */
		date: /^((?:19|20)\d\d)-(0[1-9]|1[012])-(0[1-9]|[12][0-9]|3[01])$/,
		datetime: /^((?:19|20)\d\d)-(0[1-9]|1[012])-(0[1-9]|[12][0-9]|3[01]) (([0-2][0-9]):([0-5][0-9])|([0-2][0-9]):([0-5][0-9]):([0-5][0-9]))$/,
		time: /^([0-2][0-9]):([0-5][0-9])$/,
		/**
		 * @description 身份证
		 */
		idCard: /^(^[1-9]\d{7}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{3}$)|(^[1-9]\d{5}[1-9]\d{3}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])((\d{4})|\d{3}[Xx])$)|(^[A-Z][0-9]{9})|(^[A-Z][0-9]{6}\([0-9A-Z]\))|([157][0-9]{6}\([0-9]\))$/
	};
	var _testHook = {
		//验证是否合法的价格
		is_money: function(field) {
			return regexs.money.test(backVal(field));
		},
		// 验证合法邮箱
		is_email: function(field) {
			return regexs.email.test(backVal(field));
		},
		// 验证合法 ip 地址
		is_ip: function(field) {
			return regexs.ip.test(backVal(field));
		},
		// 验证传真
		is_fax: function(field) {
			return regexs.fax.test(backVal(field));
		},
		// 验证座机
		is_tel: function(field) {
			return regexs.fax.test(backVal(field));
		},
		// 验证手机
		is_phone: function(field) {
			return regexs.phone.test(backVal(field));
		},
		// 验证URL
		is_url: function(field) {
			return regexs.url.test(backVal(field));
		},
		// 验证日期
		is_date: function(field) {
			return regexs.date.test(backVal(field));
		},
		// 验证时间
		is_datetime: function(field) {
			return regexs.datetime.test(backVal(field));
		},
		//验证时分
		is_time: function(field) {
			return regexs.time.test(backVal(field));
		},
		//验证身份证号
		is_idCard: function(field) {
			return regexs.idCard.test(backVal(field));
		},
		// 是否为必填
		required: function(field) {
			var value = backVal(field);
			return value !== null && value !== "";
		},
		// 最大长度
		max_length: function(field, length) {
			if(!regexs.numericRegex.test(length)) return false;
			return backVal(field).length <= parseInt(length, 10);
		},
		// 最小长度
		min_length: function(field, length) {
			if(!regexs.numericRegex.test(length)) return false;
			return backVal(field).length >= parseInt(length, 10);
		}
	};

	function backVal(field) {
		return typeof field === "string" ? field : field.value;
	}

	//验证单个字段
	var _validateField = function(field) {
		var rules = field.rules.split("|"),
			isEmpty = !field.value || field.value === "" || field.value === undefined;
		for(var i = 0, ruleLength = rules.length; i < ruleLength; i++) {
			var method = rules[i];
			var parts = regexs.rule.exec(method);
			var param = null;
			var failed = false;
			// 解析带参数的验证如 max_length(12)
			if(parts) method = parts[1], param = parts[2];
			if(typeof _testHook[method] === "function") {
				if(!_testHook[method].apply(this, [field, param])) {
					failed = true;
				}
			}
			if(regexs[method] && /^regexp\_/.test(method)) {
				if(!regexs[method].test(field.value)) {
					failed = true;
				}
			}
			//错误就将消息写入到错误集合中
			if(failed) {
				var message = function() {
					return field.display.split("|")[i] && field.display.split("|")[i].replace("{{" + field.name + "}}", field.value);
				}();
				errors.push(message)
			}
		}
	}

	//根据规则进行验证
	for(var i in fields) {
		_validateField(fields[i])
	}
	if(errors.length > 0) {
		failedCallback(errors)
	} else {
		successCallback()
	}

}

//========================================================
//公用的一些方法和事件
window.debug = function(msgOrObj) {
	if(toolkit.debug) {
		try {
			invalidfunctionthrowanerrorplease();
		} catch(err) {
			var logStack = err.stack;
		}
		console.log(JSON.stringify(msgOrObj)); //输出数据
		//输出堆栈信息
		var fullTrace = logStack.split('\n');
		for(var i = 0; i < fullTrace.length; ++i) {
			fullTrace[i] = fullTrace[i].replace(/\s+/g, ' ').replace(/file:\/\/.+HBuilder/, "");
		}
		//去掉第一个，第一个是函数自己
		fullTrace.shift();
		console.warn(fullTrace.join("    "));
		console.warn("----------------------");
	}
}